# Include file used for all project makefiles

# Build dependency rules
# ===============================================================
VBCRC32_DEP = vbcrc32.h \
	vbcrctab.h

VBDREF_DEP = vbdref.h

VBDERROR_DEP = vbderror.h

VBINT32_DEP = vbdtypes.h \
	vbint32.h

VBDFPTR_DEP = vbdtypes.h \
	vbdfptr.h \
	vbheader.h \
	vbd_ver.h \
	vbint32.h \
	vbuint32.h

VBDBASE_DEP = vbdtypes.h \
	vbheader.h \
	vbdfptr.h \
	vbderror.h \
	vbd_ver.h \
	vbint32.h \
	vbdbase.h \
	vbcrc32.h \
	vbuint32.h

VBUINT32_DEP = vbdtypes.h \
	vbuint32.h

VBSTAT32_DEP = vbdtypes.h \
	vbheader.h \
	vbdfptr.h \
	vbderror.h \
	vbd_ver.h \
	vbint32.h \
	vbdbase.h \
	vbuint32.h \
	vbstat32.h \
	vbcrc32.h

THELPERS_DEP = ../../include/thrtypes.h ../../include/thelpers.h

THRAPIW_DEP = ../../include/thrtypes.h ../../include/thrapiw.h \
	../../include/vthreadt.h ../../include/vbthread.h \
	../../include/thrpool.h ../../include/vbmutex.h \
	../../include/vbcond.h ../../include/thelpers.h

THRPOOL_DEP = ../../include/thrtypes.h ../../include/thrpool.h \
	../../include/vthreadt.h

VBCOND_DEP = ../../include/thrtypes.h ../../include/vbcond.h \
	../../include/thelpers.h ../../include/vbmutex.h

VBMUTEX_DEP = ../../include/thrtypes.h ../../include/vbmutex.h \
	../../include/thelpers.h

VBSEMA_DEP = ../../include/thrtypes.h ../../include/vbsema.h \
	../../include/thelpers.h

VBTHREAD_DEP = ../../include/thrtypes.h  ../../include/vbthread.h \
	../../include/vthreadt.h ../../include/thrapiw.h \
	../../include/thrpool.h

VTHREADT_DEP = ../../include/thrtypes.h ../../include/vthreadt.h \
	../../include/vbthread.h ../../include/thrpool.h \
	../../include/vbcond.h ../../include/vbmutex.h \
	../../include/thelpers.h

TESTPROG_DEP = vbdtypes.h \
	vbheader.h \
	vbdfptr.h \
	vbderror.h \
	vbd_ver.h \
	vbint32.h \
	vbdbase.h \
	vbcrc32.h \
	vbuint32.h \
	../../include/thrtypes.h ../../include/thelpers.h \
	../../include/vbthread.h ../../include/vthreadt.h \
	../../include/thrpool.h ../../include/vbmutex.h \
	../../include/vbcond.h ../../include/vbsema.h
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT)$(EXE_EXT)

vbderror$(OBJ_EXT):	vbderror.cpp $(VBDERROR_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	vbderror.cpp

vbint32$(OBJ_EXT):	vbint32.cpp $(VBINT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	vbint32.cpp

vbdfptr$(OBJ_EXT):    vbdfptr.cpp $(VBDFPTR_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	vbdfptr.cpp

vbdbase$(OBJ_EXT):    vbdbase.cpp $(VBDBASE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	vbdbase.cpp

vbuint32$(OBJ_EXT):	vbuint32.cpp $(VBUINT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	vbuint32.cpp

vbcrc32$(OBJ_EXT):	vbcrc32.cpp $(VBCRC32_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	vbcrc32.cpp

vbstat32$(OBJ_EXT):	vbstat32.cpp $(VBSTAT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	vbstat32.cpp

thrapiw$(OBJ_EXT):	../../src/thrapiw.cpp $(THRAPIW_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/thrapiw.cpp

thelpers$(OBJ_EXT):	../../src/thelpers.cpp $(THELPERS_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/thelpers.cpp

thrpool$(OBJ_EXT):	../../src/thrpool.cpp $(THRPOOL_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/thrpool.cpp

vbthread$(OBJ_EXT):	../../src/vbthread.cpp $(VBTHREAD_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbthread.cpp

vthreadt$(OBJ_EXT):	../../src/vthreadt.cpp $(VTHREADT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vthreadt.cpp

vbmutex$(OBJ_EXT):	../../src/vbmutex.cpp $(VBMUTEX_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbmutex.cpp

vbcond$(OBJ_EXT):	../../src/vbcond.cpp $(VBCOND_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbcond.cpp

vbsema$(OBJ_EXT):	../../src/vbsema.cpp $(VBSEMA_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbsema.cpp

testprog$(OBJ_EXT):	testprog.cpp $(TESTPROG_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) testprog.cpp

# Make the executable
OBJECTS = vbderror$(OBJ_EXT) vbint32$(OBJ_EXT) vbdbase$(OBJ_EXT) \
	vbcrc32$(OBJ_EXT) vbuint32$(OBJ_EXT) vbstat32$(OBJ_EXT) \
	vbdfptr$(OBJ_EXT) testprog$(OBJ_EXT) vbthread$(OBJ_EXT) \
	vbmutex$(OBJ_EXT) thrpool$(OBJ_EXT) vthreadt$(OBJ_EXT) \
	vbcond$(OBJ_EXT) vbsema$(OBJ_EXT) thrapiw$(OBJ_EXT) \
	thelpers$(OBJ_EXT)  
# ===============================================================
